| IGLib 1.6.0 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Public Member Functions | Properties | List of all members
IG.Num.IPenaltyEvaluator Interface Reference

Classes that evaluates penalty terms corresponding to a specific penalty function. More...

Inheritance diagram for IG.Num.IPenaltyEvaluator:
[legend]

## Public Member Functions
void | SetPenaltyFunction (int which, IRealFunctionPenalty function)
| Sets the penalty function used for evaluation of the specified penalty term. More...
void | SetPenaltyFunction (int which, double barrierLength, double barrierHeight)
| Sets the penalty function used for evaluation of the specified penalty term. More...
void | SetPenaltyFunction (int which, double barrierLength, double barrierHeight, double zeroEnd)
| Sets the penalty function used for evaluation of the specified penalty term. More...
bool | CanSetBarrierLength (int which)
| Returns a flag that tells whether characteristic barrier length can be set for the penalty function of the specified constraint. More...
bool | CansetBarrierHeight (int which)
| Returns a flag that tells whether characteristic barrier height can be set for the penalty function of the specified constraint. More...
bool | CanSetMaxZero (int which)
| Returns a flag that tells whether maxmal argument where function is zero can be set for the penalty function of the specified constraint. More...
int | AddPenaltyFunction (IRealFunctionPenalty func)
| Adds a new penalty function for evaluation of penalty terms to the list. More...
IRealFunctionPenalty | GetPenaltyFunction (int which)
| Returns penalty function corresonding to the specified constraint. More...
bool | IsPenaltyValueDefined (int which)
| Returns true if the penalty function value can be calculated for the specified constraint, or false otherwise. More...
bool | IsPenaltyDerivativeDefined (int which)
| Returns true if the penalty function derivative can be calculated for the specified constraint, or false otherwise. More...
bool | IsPenaltySecodDerivativeDefined (int which)
| Returns true if the penalty function's second can be calculated for the specified constraint, or false otherwise. More...
double | PenaltyValue (int which, double constraintValue)
| Returns value of the penalty function for the specified constraint at the specified value of the corresponding constraint function. More...
double | PenaltyDerivative (int which, double constraintValue)
| Returns derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value. More...
double | PenaltySecondDerivative (int which, double constraintValue)
| Returns second derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value. More...

## Properties
bool | AllowSingleFunction`[get, set]`
| Whether a single function can be used for evaluating penalty terms corresponding to different constraints. More...
List< IRealFunctionPenalty > | PenaltyFunctions`[get]`
| Returns a list of penalty functions used to evaluate penalty terms. More...

## Detailed Description

Classes that evaluates penalty terms corresponding to a specific penalty function.

## Member Function Documentation

void IG.Num.IPenaltyEvaluator.SetPenaltyFunction | ( | int | which,
|  | IRealFunctionPenalty | function
| ) |  |

Sets the penalty function used for evaluation of the specified penalty term.

Parameters

  which | Specifies which conatraint the penalty function applies to (zero based). In order to use one penalty function for all constraints, just set the penalty function with index 0.
  function | Function to be used for evaluation of the specified penalty term.

Implemented in IG.Num.PenaltyEvaluator.

void IG.Num.IPenaltyEvaluator.SetPenaltyFunction | ( | int | which,
|  | double | barrierLength,
|  | double | barrierHeight
| ) |  |

Sets the penalty function used for evaluation of the specified penalty term.

Parameters

  which | Specifies which conatraint the penalty function applies to (zero based). In order to use one penalty function for all constraints, just set the penalty function with index 0.
  barrierLength | Characteristic barrier length of the created function. This is the length at which function grows from approximately 0 to characteristic height.
  barrierHeight | Characteristic barrier height of the created function.

Implemented in IG.Num.PenaltyEvaluator.

void IG.Num.IPenaltyEvaluator.SetPenaltyFunction | ( | int | which,
|  | double | barrierLength,
|  | double | barrierHeight,
|  | double | zeroEnd
| ) |  |

Sets the penalty function used for evaluation of the specified penalty term.

Parameters

  which | Specifies which conatraint the penalty function applies to (zero based). In order to use one penalty function for all constraints, just set the penalty function with index 0.
  barrierLength | Characteristic barrier length of the created function. This is the length at which function grows from approximately 0 to characteristic height.
  barrierHeight | Characteristic barrier height of the created function.
  zeroEnd | Maximal argumet for which penalty function is still 0.

Implemented in IG.Num.PenaltyEvaluator.

bool IG.Num.IPenaltyEvaluator.CanSetBarrierLength | ( | int | which | ) |

Returns a flag that tells whether characteristic barrier length can be set for the penalty function of the specified constraint.

Parameters

  which | Specified the constraiint in question.

Implemented in IG.Num.PenaltyEvaluator.

bool IG.Num.IPenaltyEvaluator.CansetBarrierHeight | ( | int | which | ) |

Returns a flag that tells whether characteristic barrier height can be set for the penalty function of the specified constraint.

Parameters

  which | Specified the constraiint in question.

Implemented in IG.Num.PenaltyEvaluator.

bool IG.Num.IPenaltyEvaluator.CanSetMaxZero | ( | int | which | ) |

Returns a flag that tells whether maxmal argument where function is zero can be set for the penalty function of the specified constraint.

Parameters

  which | Specified the constraiint in question.

Implemented in IG.Num.PenaltyEvaluator.

int IG.Num.IPenaltyEvaluator.AddPenaltyFunction | ( | IRealFunctionPenalty | func | ) |

Adds a new penalty function for evaluation of penalty terms to the list.

Parameters

  func | Function to be added.

Returns
  Index of the added penalty function (0 if this is the first function on the list).

Implemented in IG.Num.PenaltyEvaluator.

IRealFunctionPenalty IG.Num.IPenaltyEvaluator.GetPenaltyFunction | ( | int | which | ) |

Returns penalty function corresonding to the specified constraint.

Parameters

  which | Index of penalty function (or the corresponding constraint).

Implemented in IG.Num.PenaltyEvaluator.

bool IG.Num.IPenaltyEvaluator.IsPenaltyValueDefined | ( | int | which | ) |

Returns true if the penalty function value can be calculated for the specified constraint, or false otherwise.

Parameters

  which | Specifies the constraint in question.

Implemented in IG.Num.PenaltyEvaluator.

bool IG.Num.IPenaltyEvaluator.IsPenaltyDerivativeDefined | ( | int | which | ) |

Returns true if the penalty function derivative can be calculated for the specified constraint, or false otherwise.

Parameters

  which | Specifies the constraint in question.

Implemented in IG.Num.PenaltyEvaluator.

bool IG.Num.IPenaltyEvaluator.IsPenaltySecodDerivativeDefined | ( | int | which | ) |

Returns true if the penalty function's second can be calculated for the specified constraint, or false otherwise.

Parameters

  which | Specifies the constraint in question.

Implemented in IG.Num.PenaltyEvaluator.

double IG.Num.IPenaltyEvaluator.PenaltyValue | ( | int | which,
|  | double | constraintValue
| ) |  |

Returns value of the penalty function for the specified constraint at the specified value of the corresponding constraint function.

Parameters

  which | Specifies the constraint in question.
  constraintValue | Value of the constraint function for which penalty value is returned.

Implemented in IG.Num.PenaltyEvaluator.

Referenced by IG.Num.AnalysisResults.GetPenaltyTerm().

double IG.Num.IPenaltyEvaluator.PenaltyDerivative | ( | int | which,
|  | double | constraintValue
| ) |  |

Returns derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value.

Parameters

  which | Specifies the constraint in question.
  constraintValue | Value of the constraint function for which penalty derivative is returned.

Implemented in IG.Num.PenaltyEvaluator.

double IG.Num.IPenaltyEvaluator.PenaltySecondDerivative | ( | int | which,
|  | double | constraintValue
| ) |  |

Returns second derivative of the penalty function for the specified constraint at the specified value of the corresponding constraint function, with respect to constraint value.

Parameters

  which | Specifies the constraint in question.
  constraintValue | Value of the constraint function for which penalty second derivative is returned.

Implemented in IG.Num.PenaltyEvaluator.

## Property Documentation

bool IG.Num.IPenaltyEvaluator.AllowSingleFunction
| get set

Whether a single function can be used for evaluating penalty terms corresponding to different constraints.

List<IRealFunctionPenalty> IG.Num.IPenaltyEvaluator.PenaltyFunctions
| get

Returns a list of penalty functions used to evaluate penalty terms.

The documentation for this interface was generated from the following file:

- igbase/optimization/AnalysisResutlsInt.cs